#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["SpellFinal"]
#Text["SpellFinal"]
#System["./../../../ds_system/S_System.txt"]
#Background["./Background.h"]
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let timer = 0;
let start = 0;
let sucker;
let expeller;
let imgSigil = GetCurrentScriptDirectory ~ "sigil2.png";

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 200, 70, 40);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/4,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(6500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(120);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 250) {AimedShot;}
	if (timer == 375&&ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 3501) {timer = 249;}
	if (timer == 500) {timer = 249;}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3(" \"Life Cycle of All Aquatic Fauna\" ", GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4(" \"Life Cycle of All Aquatic Fauna\" ", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"13.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
	Finale;
	Timedcharges;
	GlowShot;
}

task Finale{
	let dir = 90;
	wait(100);
	ConcentrationA1(Boss,"CHERRY",80,3,110,[255,128,64]); PlaySoundB1("se_ch02", 65);
	wait(60);
	wait(40);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		loop(5){ //was 4
			let lead = CreateCollisionShotA1(BossX,BossY,0.7,dir,259,10); //speed was 0.4
			/*let ring1 = CreateShotA1(BossX,BossY,0.4,dir,500,10);
			ObjShot_SetIntersectionEnable(ring1,false);
			let ring2 = CreateShotA1(BossX,BossY,0.4,dir,501,10);
			ObjShot_SetIntersectionEnable(ring2,false);
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 5500){let ring3 = CreateShotA1(BossX,BossY,0.4,dir,502,10); ObjShot_SetIntersectionEnable(ring3,false);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 4500){let ring4 = CreateShotA1(BossX,BossY,0.4,dir,503,10); ObjShot_SetIntersectionEnable(ring4,false);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 3500){let ring5 = CreateShotA1(BossX,BossY,0.4,dir,504,10); ObjShot_SetIntersectionEnable(ring5,false);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 1500){let ring6 = CreateShotA1(BossX,BossY,0.4,dir,505,10); ObjShot_SetIntersectionEnable(ring6,false);}*/
			ObjShot_SetSpellResist(lead,true);
			ObjRender_SetAlpha(lead,50);
			  Obj_SetValue(lead, "g_Coll_Ignore", true);
			let fish = [];
			
			/*FishOrbitersB1(lead,7,0.7,1,25,67);
 			FishOrbitersB1(lead,7,0.8,-1,55,69);
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 5500){FishOrbitersB1(lead,7,0.7,1,75,74);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 4500){FishOrbitersB1(lead,5,1.5,-1,90,76);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 3500){FishOrbitersB1(lead,7,0.6,1,145,71);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 2500){FishOrbitersB1(lead,7,0.6,-1,145,72);}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 1500){FishOrbitersB1(lead,4,1.5,1,170,75);} */
			
			fish = fish~[[4,0.5,1,25,67]];
			fish = fish~[[7,0.8,-1,65,69]];
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 5500){fish = fish~[[7,0.7,1,85,74]];}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 4500){fish = fish~[[7,1,-1,110,76]];}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 3500){fish = fish~[[10,0.6,1,145,71]];}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 2500){fish = fish~[[10,0.6,-1,145,72]];}
			if(ObjEnemy_GetInfo(Boss, INFO_LIFE) <= 1500){fish = fish~[[12,1,1,170,75]];}
			
			FishOrbitersB1(lead,fish);
			
			dir+=360/5; //was 4
		}
		dir+=360/5/2;
		PlaySoundB1("se_enep02",70);
		wait(360);
	}
}

task FishOrbitersB1(obj,vars){
	//amt,spd,dir,dist,col
	
	// let lobj = ID_INVALID;
	
	// lobj = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	// Obj_SetRenderPriority(lobj, 0.29);
	// ObjPrim_SetTexture(lobj, img_Outline);
	// ObjSpriteList2D_SetSourceRect(lobj, 0, 0, 1024, 1024);
	// ObjSpriteList2D_SetDestCenter(lobj);
	
	let objx = ObjMove_GetX(obj);
	let objy = ObjMove_GetY(obj);
	
	let xm = 0;
	let ym = 0;
	
	let zx = objx;
	let zy = objy;
	
	let bdel = 12;
	
	let sang = 0;
	
	// ascent(i in 0..amt){
		// sang+=360/(amt-1);
		// let lx = dist*cos(sang);
		// let ly = dist*sin(sang);
		// FireFishA1(objx+lx,objy+ly,circum/time,sang+90*dir,col,bdel)
	// }
	
	ascent(i in 0..length(vars)){
		let vals = vars[i];
		//amt,spd,dir,dist,col
		CreateRing(vals[3], vals[4], vals[0], vals[1], 0, vals[2]);
	}
	// ObjSpriteList2D_CloseVertex(lobj);
	// Obj_Delete(lobj);
	
	while(!Obj_IsDeleted(obj)){
		objx = ObjMove_GetX(obj);
		objy = ObjMove_GetY(obj);
		
		if(zx != objx){
			xm = objx-zx;
			zx = objx;
		}
		
		if(zy != objy){
			ym = objy-zy;
			zy = objy;
		}
		// ObjRender_SetPosition(lobj, objx, objy, 0);
		
		yield;
		
		xm = 0;
		ym = 0;
		
	}
	// Obj_Delete(lobj);
	
/* 	
	task FireFishA1(x, y, spd, ang, graph, del){
		
		let a = CreateShotA1(x, y, spd, ang, graph, del);
		ObjShot_SetSpellResist(a,true);
		ObjShot_SetAutoDelete(a, false);
		ObjMove_AddPatternA2(a, del, NO_CHANGE, NO_CHANGE, 0, 360/time*dir, NO_CHANGE);
		
		
		
		while(!Obj_IsDeleted(obj)){
			ObjMove_SetX(a, ObjMove_GetX(a)+xm);
			ObjMove_SetY(a, ObjMove_GetY(a)+ym);
			yield;
		}
		Obj_Delete(a);
	}
	 */
	
	task CreateRing(dist, li, bcount, sspd, sang, mod){
		let circum = 2*pi*dist;
		let time = circum/sspd;
		
		// lobj = CreateSimple2DImageA1(0.29, img_Outline);
		// ObjRender_SetColor(lobj, 255, 255, 255);
		// ObjRender_SetPosition(lobj, x, y, 0);
		
		// ObjRender_SetScaleXYZ(lobj, dist/512, dist/512, 1);
		// ObjSpriteList2D_AddVertex(lobj);
		
		// if(dist == vsize){
			// obj = ObjPrim_Create(OBJ_PRIMITIVE_2D);
			// ObjPrim_SetPrimitiveType(obj, PRIMITIVE_LINESTRIP);
			// ObjPrim_SetVertexCount(obj, bcount+1);
			// ObjPrim_SetTexture(obj, img_Blank);
			// ObjRender_SetPosition(obj, objx, objy, 0);
		// }
		
		ascent(i in 0..bcount){
			
			// ObjMove_AddPatternA2(a, GetStgFrameHeight*0.7/sspd+argument, NO_CHANGE, NO_CHANGE, 0, 360/time*mod*1.3, NO_CHANGE);
			//ObjMove_SetAngularVelocity(a, 360/time*mod);
			// barr = barr~[a];
FireLocalBullet(sang);
			// if(dist == vsize){
				// ObjPrim_SetVertexUVT(obj, i, 0, 0);
				// ObjPrim_SetVertexPosition(obj, i, lx, ly, 0);
			// }
			sang+=360/(bcount);	
		}
		// ObjPrim_SetVertexUVT(obj, bcount, 0, 0);
		// ObjPrim_SetVertexPosition(obj, bcount, dist, 0, 0);
		//ObjRender_SetAngleZ(obj, sang);
		
		// while(!Obj_IsDeleted(obj)){
			// ascent(i in 0..length(barr)){
				// let a = barr[i];
				// ObjMove_SetX(a, ObjMove_GetX(a)+xm);
				// ObjMove_SetY(a, ObjMove_GetY(a)+ym);
			// }
			// ObjRender_SetPosition(lobj, objx, objy, 0);
			// ObjRender_SetAngleZ(obj, sang);
			// sang+=360/time*mod;
			// yield;
		// }
		// ascent(i in 0..length(barr)){
			// Obj_Delete(barr[i]);
		// }
		// Obj_Delete(lobj);
		
		task FireLocalBullet(sang){
			let lx = dist*cos(sang);
			let ly = dist*sin(sang);
			let a = CreateCollisionShotA1(objx+lx, objy+ly, circum/time, sang+90*mod, li, bdel);
			//ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			ObjShot_SetAutoDelete(a, false);
			ObjMove_AddPatternA2(a, bdel, NO_CHANGE, NO_CHANGE, 0, 360/time*mod, NO_CHANGE);
			
			while(!Obj_IsDeleted(obj)){
				ObjMove_SetX(a, ObjMove_GetX(a)+xm);
				ObjMove_SetY(a, ObjMove_GetY(a)+ym);
				yield;
			}
			//ObjShot_BulletBreak(ObjMove_GetX(a), ObjMove_GetY(a), li);
			// Obj_Delete(a);
			ObjShot_FadeDelete(a);
		}
		
		
	}
	
}

task AimedShot{
	let dir = GetAngleToPlayer(Boss);
	loop(5){
		let color = 44;
		let spread = -12;
		ascent(i in 0..9){
			let shot = CreateCollisionShotA1(BossX,BossY,1.1,dir+spread,color,20);
			//ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
			if (i == 3) {color = 110}
			if (i == 4) {color = 44}
			spread+=24/10;
		}
		dir+=360/5;
	}
	PlaySoundB1("se_kira01",60);
}

task GlowShot{
	wait(200);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
	
		let dir = rand(0,360);
		loop(4){
			loop(9){
				CreateCollisionShotA1(BossX,BossY,1.7,dir,235,20);
				dir+=360/9;
			}
			dir+=12;
			PlaySoundB1("se_boon00",60);
			wait(30);
		}
		wait(30);
		dir = rand(0,360);
		loop(4){
			loop(9){
				CreateCollisionShotA1(BossX,BossY,1.7,dir,235,20);
				dir+=360/9;
			}
			dir-=12;
			PlaySoundB1("se_boon00",60);
			wait(30);
		}
		wait(30);
	}
}

task Timedcharges{
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 5501){yield;}
	ConcentrationA1(Boss,"CHERRY",80,3,110,[64,64,255]); PlaySoundB1("se_ch02", 65);
	
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 4501){yield;}
	ConcentrationA1(Boss,"CHERRY",80,3,110,[255,64,255]); PlaySoundB1("se_ch02", 65);

	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 3501){yield;}
	ConcentrationA1(Boss,"CHERRY",80,3,110,[64,255,64]); PlaySoundB1("se_ch02", 65);

	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 2501){yield;}
	ConcentrationA1(Boss,"CHERRY",80,3,110,[64,255,255]); PlaySoundB1("se_ch02", 65);

	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) >= 1501){yield;}
	ConcentrationA1(Boss,"CHERRY",80,3,110,[255,64,255]); PlaySoundB1("se_ch02", 65);
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_enep01",80);
	// ExplosionRainbowB1(Boss,"CHERRY");
	
	ExplosionB2(Boss,"CHERRY",[96, 144, 224],[144, 112, 224]);
	NotifyEventAll(EV_SIGIL_OFF, 0);
	
	loop(160){yield;}
	// Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}